/*
 * Glob.cs --
 *
 * Copyright (c) 2007-2012 by Joe Mistachkin.  All rights reserved.
 *
 * See the file "license.terms" for information on usage and redistribution of
 * this file, and for a DISCLAIMER OF ALL WARRANTIES.
 *
 * RCS: @(#) $Id: $
 */

using Eagle._Attributes;
using Eagle._Components.Public;
using Eagle._Containers.Public;
using Eagle._Interfaces.Public;

namespace Eagle._Commands
{
    [ObjectId("92dc78d3-6dce-4f68-9459-9d3510b1ce7d")]
    [CommandFlags(CommandFlags.Unsafe | CommandFlags.Standard)]
    [ObjectGroup("fileSystem")]
    internal sealed class Glob : Core
    {
        public Glob(
            ICommandData commandData
            )
            : base(commandData)
        {
            // do nothing.
        }

        #region IExecute Members
        public override ReturnCode Execute(
            Interpreter interpreter,
            IClientData clientData,
            ArgumentList arguments,
            ref Result result
            )
        {
            //
            // TODO: Implement me.
            //
            result = "not implemented";
            return ReturnCode.Error;

            /*
            ReturnCode code = ReturnCode.Ok;

            if (interpreter != null)
            {
                if (arguments != null)
                {
                    if (arguments.Count >= 2)
                    {
                        OptionDictionary options = new OptionDictionary(
                            new Option[] { 
                                new Option(null, OptionFlags.None, Index.Invalid, Index.Invalid, "-join", null),
                                new Option(null, OptionFlags.None, Index.Invalid, Index.Invalid, "-nocomplain", null),
                                new Option(null, OptionFlags.None, Index.Invalid, Index.Invalid, "-tails", null),
                                new Option(null, OptionFlags.MustHaveValue, Index.Invalid, Index.Invalid, "-directory", null),
                                new Option(null, OptionFlags.MustHaveValue, Index.Invalid, Index.Invalid, "-path", null),
                                new Option(null, OptionFlags.MustHaveValue | OptionFlags.MustBeList | OptionFlags.Unsupported, Index.Invalid, Index.Invalid, "-types", null),
                                new Option(null, OptionFlags.None, Index.Invalid, Index.Invalid, Common.EndOfOptions, null)
                            });

                        int argumentIndex = Index.Invalid;

                        code = interpreter.GetOptions(options, arguments, 0, 1, Index.Invalid, true, ref argumentIndex, ref result);

                        if (code == ReturnCode.Ok)
                        {
                            if (argumentIndex != Index.Invalid)
                            {
                                Variant value = null;
                                string directory = null;

                                if (options.IsPresent("-directory", ref value))
                                    directory = value.ToString();

                                string pathPrefix = null;

                                if (options.IsPresent("-path", ref value))
                                    pathPrefix = value.ToString();

                                if ((directory == null) || (pathPrefix == null))
                                {
                                    if (directory != null)
                                        directory = Common.NormalizePath(null, directory, false, true, true, false);
                                    else
                                        directory = Directory.GetCurrentDirectory();

                                    bool join = false;

                                    if (options.IsPresent("-join"))
                                        join = true;

                                    bool noComplain = false;

                                    if (options.IsPresent("-nocomplain"))
                                        noComplain = true;

                                    bool tails = false;

                                    if (options.IsPresent("-tails"))
                                        tails = true;

                                    StringList patterns = new StringList();

                                    if (join)
                                        patterns.Add(Common.Concat(arguments, argumentIndex, Path.AltDirectorySeparatorChar.ToString()));
                                    else
                                        patterns.Add(arguments, argumentIndex);

                                    StringList paths = null;

                                    //
                                    // FIXME: Implement Tcl compatible glob semantics.
                                    //
                                    // code = Common.DoGlob(directory, pathPrefix, patterns, noComplain, tails, ref paths, ref result);

                                    if (code == ReturnCode.Ok)
                                        result = paths;
                                }
                                else
                                {
                                    result = "\"-path\" cannot be used with \"-directory\"";
                                    code = ReturnCode.Error;
                                }
                            }
                            else
                            {
                                result = "wrong # args: should be \"glob ?switches? pattern ?pattern ...?\"";
                                code = ReturnCode.Error;
                            }
                        }
                    }
                    else
                    {
                        result = "wrong # args: should be \"glob ?switches? pattern ?pattern ...?\"";
                        code = ReturnCode.Error;
                    }
                }
                else
                {
                    result = "invalid argument list";
                    code = ReturnCode.Error;
                }
            }
            else
            {
                result = "invalid interpreter";
                code = ReturnCode.Error;
            }

            return code;
            */
        }
        #endregion
    }
}
