/*
 * AssemblyReleaseAttribute.cs --
 *
 * Copyright (c) 2007-2012 by Joe Mistachkin.  All rights reserved.
 *
 * See the file "license.terms" for information on usage and redistribution of
 * this file, and for a DISCLAIMER OF ALL WARRANTIES.
 *
 * RCS: @(#) $Id: $
 */

using System;
using System.Runtime.InteropServices;

namespace Eagle._Attributes
{
    [AttributeUsage(AttributeTargets.Assembly, Inherited = false)]
    [Guid("922410b6-d112-4bcd-a452-b064a9ad3123")]
    public sealed class AssemblyReleaseAttribute : Attribute
    {
        public AssemblyReleaseAttribute(string value)
        {
            release = value;
        }

        ///////////////////////////////////////////////////////////////////////////////////////////////

        private string release;
        public string Release
        {
            get { return release; }
        }
    }
}
